#ifndef STRINGPASSER_H
#define STRINGPASSER_H

#include <QObject>
#include <QImage>
#include <QUrl>

class Decoder : public QObject
{
    Q_OBJECT
    Q_ENUMS(DecoderFormat)

public:
    enum DecoderFormat {
                    DecoderFormat_None = 0,
                    DecoderFormat_QR_CODE = 1,
                    DecoderFormat_DATA_MATRIX = 2,
                    DecoderFormat_UPC_E = 4,
                    DecoderFormat_UPC_A = 8,
                    DecoderFormat_EAN_8 = 16,
                    DecoderFormat_EAN_13 = 32,
                    DecoderFormat_CODE_128 = 64,
                    DecoderFormat_CODE_39 = 128,
                    DecoderFormat_ITF = 256,
                    DecoderFormat_Aztec = 512
            } ;
    typedef unsigned int DecoderFormatType;

public:
    explicit Decoder(QObject *parent = 0);
    void setDecoder(DecoderFormatType hint);
    
signals:
    void decodingStarted();
    void decodingFinished(bool succeeded);
    void tagFound(QString tag);
    
public slots:
    Q_INVOKABLE QString decodeImage(QImage image);
    Q_INVOKABLE QString decodeImageQML(const QUrl &item);

private:
    void* decoder;
    DecoderFormatType supportedFormats;
    QObject* imageHandler;
};

#endif // STRINGPASSER_H
