import QtQuick 2.0
import Decoder 1.0
import QtMultimedia 5.0

Rectangle {
    width: 360
    height: 360
    Text {
        text: qsTr("Hello World")
        anchors.centerIn: parent
    }

    Camera {
        id: camera
        flash.mode: Camera.FlashOff
        captureMode: Camera.CaptureStillImage
        focus.focusMode: Camera.FocusAuto
        exposure.exposureMode: Camera.ExposureAuto

        imageCapture {
            onImageCaptured: {
                // Show the preview in an Image
                console.log("Captured Image:" + preview);
                //photoPreview.source = preview;
                //decoder.decodeImageQML(photoPreview);
                //console.log('[QML] Image URL: ' + photoPreview.source)
                decoder.decodeImageQML(preview);
                //decoder.decodeImageQML('/home/dpm/Escriptori/Collsacabra.jpg');

            }

            onImageSaved: {
                console.log("Picture saved as " + path)
                //decoder.decodeImageQML(path);
            }
        }
    }

    Decoder {
        id: decoder
        onTagFound: {
            console.log("Tag found: " + tag)
        }

        onDecodingStarted: {
            console.log("Decoding started")
        }

        onDecodingFinished: {
            console.log("Decoding finished " + (succeeded==true ? "successfully" : "unsuccessfully"))
        }

    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            //qmlconnect.decodeImageQML("/tmp/imgme.jpg");
            camera.imageCapture.captureToLocation("/tmp/imgme.jpg")
            //Qt.quit();
        }
    }
}
